Bug 1652228 - glibc: Do not use parallel make for building locales
Summary: glibc: Do not use parallel make for building locales
Status: ON_QA
Alias: None
Product: Fedora
Classification: Fedora
Component: glibc
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Florian Weimer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 1652229
TreeView+ depends on / blocked
 
Reported: 2018-11-21 17:49 UTC by Florian Weimer
Modified: 2019-06-10 21:36 UTC (History)
9 users (show)

(edit)
Clone Of:
: 1652229 (view as bug list)
(edit)
Last Closed:


Attachments (Terms of Use)

Description Florian Weimer 2018-11-21 17:49:54 UTC
localedef uses hard links to avoid storing the same data repeatedly across locales, but the hardlink groups are different depending on how the localedef invocations are scheduled by make.

This leads to differences in the generated RPM files—the column “6:19” in the first row is RPM's pseudo-inode number followed by the link count.

--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_AE.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_AE.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_AE/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_BH.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_BH.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_BH/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_DZ.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_DZ.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_DZ/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_EG.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_EG.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_EG/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_IN/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_IQ.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_IN/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_IQ.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_IQ/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_JO.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_JO.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_JO/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_KW.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_KW.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_KW/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_LB.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_LB.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_LB/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_LY.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_LY.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_LY/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_MA.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_MA.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_MA/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_OM.utf8/LC_CTYPE
+-rw-r--r-- () 300:1 {(none)} root root 337024 - /usr/lib/locale/ar_OM.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_OM/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_QA.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_QA.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_QA/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_SA.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_SA.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_SA/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_SD.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_SD.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_SD/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_SS/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_SY.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_SS/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_SY.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_SY/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_TN.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_TN.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_TN/LC_CTYPE
--rw-r--r-- () 6:19 {(none)} root root 337024 - /usr/lib/locale/ar_YE.utf8/LC_CTYPE
+-rw-r--r-- () 6:18 {(none)} root root 337024 - /usr/lib/locale/ar_YE.utf8/LC_CTYPE
 -rw-r--r-- () 19:17 {(none)} root root 288796 - /usr/lib/locale/ar_YE/LC_CTYPE

If there are fewer hardlinks as the result of these races, then installation size and RPM size increases due to data duplication.

Comment 2 Fedora Update System 2018-11-28 08:58:26 UTC
glibc-2.26-32.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-f27586cce9

Comment 3 Fedora Update System 2018-11-28 13:31:46 UTC
glibc-2.27-35.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-060302dc83

Comment 4 Fedora Update System 2018-11-28 20:39:30 UTC
glibc-2.28-22.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-f6b7df660d

Comment 5 Fedora Update System 2018-11-29 02:03:10 UTC
glibc-2.27-35.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-060302dc83

Comment 6 Fedora Update System 2018-11-29 03:05:20 UTC
glibc-2.26-32.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-f27586cce9

Comment 7 Fedora Update System 2018-11-29 03:18:43 UTC
glibc-2.28-22.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-f6b7df660d

Comment 8 Fedora Update System 2018-11-30 02:50:04 UTC
glibc-2.28-22.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2018-12-04 02:22:59 UTC
glibc-2.27-35.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.